#ifndef _RESMAP_H
#define _RESMAP_H
/* resmap.c */
/************************************************************************/
/*                                                                      */
/*  Resource map handling                                               */
/*                                                                      */
/*  changes: 2000-09-01 created                                         */
/*                                                                      */
/************************************************************************/

typedef unsigned int uint32;

typedef struct
        {
          /* change this to 512 * 256 for the full 4G range */
          /*                         vvvv                   */
          uint32 iomap[2048], memmap[512];
          uint32 irqmap, dmamap, arbmap;
          int memlimit, iolimit;
        } TResMap;

/************************************************************************/

extern void InitResMap(TResMap *pMap);

extern void MergeResMap(TResMap *pDestMap, TResMap *pSrcMap);

extern void AddIOResMap(TResMap *pMap, int start, int stop);

extern void AddMemResMap(TResMap *pMap, unsigned int start, unsigned int stop);

#define AddIRQResMap(map, irq) (map)->irqmap |= 1 << (irq)

#define AddARBResMap(map, arb) (map)->arbmap |= 1 << (arb)

#define AddDMAResMap(map, dma) (map)->dmamap |= 1 << (dma)

void PrintResMap(FILE *pFile, TResMap *pMap);

#endif /* _RESMAP_H */
